open Tensor_loops
open Ids


module T_tile = Tensor_tile(Arch.AVX512)
module MM = T_tile.MM_build( struct
    let dim_gen = Dim.fresh_gen ()

    let i_dim = dim_gen ~name:"i" ()
    let j_dim = dim_gen ~name:"j" ()
    let k_dim = dim_gen ~name:"k" ()

    let a = Tensor.make ~name:"A" [|i_dim; k_dim|]
    let b = Tensor.make ~name:"B" [|k_dim; j_dim|]
    let c_name = "C"
  end)

let dull_tile = let open T_tile in let open MM in
  [A i_dim; A j_dim; A k_dim]

let pack_tile = let open T_tile in let open MM in
  [V i_dim; Pack_tens a; A i_dim; A j_dim; A k_dim]

let motoko_tile = let open T_tile in let open MM in
  [V j_dim; U (2, j_dim); S (64, k_dim); Pack_var [k_dim]; Pack_tens b;
   S (192, j_dim);S (192, i_dim); (*Pack_tens a; Pack_tens b;*) A i_dim; A k_dim; A j_dim]

let () =
  let loop_code =
    MM.gen_code motoko_tile in
  print_endline loop_code
