open Utils

module type Algebra_t = sig
  type 'a base
  type 'a term = In of 'a term base

  val in_: 'a term base -> 'a term
  val out: 'a term -> 'a term base
  val map: ('a term -> 'a term) -> 'b term -> 'a term
  val cata: ('a base -> 'a) -> 'b term -> 'a
  val ana: ('a -> 'a base) -> 'a -> 'b term
  val hylo: ('a -> 'a base) -> ('b base -> 'b) ->'a -> 'b
  val para: (('a term * 'b) base -> 'b) -> 'a term -> 'b
  val para': ('a term -> 'b base -> 'b) -> 'a term -> 'b
  val apo: ('a -> ('b term, 'a) either base) -> 'a -> 'b term 

  type 'a attr
  val attribute: 'a attr -> 'a
  val hole: 'a attr -> 'a attr base
  val mk_attr: 'a -> 'a attr base -> 'a attr

  val histo: ('a attr base -> 'a) -> 'b term  -> 'a
end

module type Mappable = sig type 'a t val map: ('a -> 'b) -> 'a t -> 'b t end

module A(M: Mappable): Algebra_t with type 'a base := 'a M.t
