open Ids
type t

type operator = Add | Mul

val tensor: Tensor.t -> t
val make_val: Dim.t list -> float -> t
val join: operator -> DimSet.t -> t -> t -> t option
val reduce: operator -> DimSet.t -> t -> t -> t option
val dims: t -> DimSet.t

type 'a foldF =
    TensF of Tensor.t
  | ValF of float
  | RedF of operator * DimSet.t * 'a * 'a
  | JoinF of operator * DimSet.t * 'a * 'a

val matmul: Tensor.t -> Tensor.t -> Dim.t -> Dim.t -> Dim.t -> t option

module FuncAlgebra : Algebra.Algebra_t with type 'a base := 'a foldF
