open Ids
open Exprs

type t [@@deriving eq, show]
type id [@@deriving eq, ord, show]
type gen = unit -> t
type accesses = (Dim.id * VarExpr.t) list  [@@deriving eq, show]

val make: ?name:string -> ?strides:(Dim.id * ConstExpr.t) list -> ?sizes:(Dim.id * ConstExpr.t) list
  -> Dim.t array -> t
val dims: t -> Dim.t array
val dims_list: t -> Dim.t list

val id: t -> id
val show_tid: t -> string

val gen_clone: t -> unit -> (t * (unit -> t))
val strides_from_size_list: t -> (Dim.id * ConstExpr.t) list -> (Dim.id * ConstExpr.t) list
val size: t -> ConstExpr.t
val dim_size: t -> Dim.id -> ConstExpr.t
val stride: t -> Dim.id -> ConstExpr.t
val acc_does_access: accesses -> Dim.id -> bool
val tens_does_access: t -> Dim.id -> bool
val does_access: t -> accesses -> Dim.id -> bool
val modify_size_stride: t -> (Dim.id * ConstExpr.t) list -> t
val map_stride: t -> (ConstExpr.t -> ConstExpr.t)  -> t
val modify_stride: t ->  Dim.id -> (ConstExpr.t option -> ConstExpr.t option)  -> t
val modify_accesses: accesses ->  Dim.id -> (VarExpr.t option -> VarExpr.t option)  -> accesses
val gen_access: t -> accesses -> string
