#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <x86intrin.h>
#define I (1 << 10)
#define J (1 << 13)
#define K (1 << 6)
#define EPSILON 0.001
#define MIN(a, b) (a < b ?a:b)


void init_zero(float A[], int M, int N) {
	for (int i = 0; i < M; i++) {
		for (int k = 0; k < N; k++) {
			A[i*N+k] = 0.;
		}
	}
}

void init_rand(float A[], int M, int N) {
	for (int i = 0; i < M; i++) {
		for (int k = 0; k < N; k++) {
			//A[i*N+k] = (float) (i*(k+1) % N) / N;
			A[i*N+k] = (float) (i * (k + 1) % N) / N;
		}
	}
}

// Is C = A * B ?
int is_matmul(float * A, float * B, float * C, int NI, int NJ, int NK) {
	float * Check = (float *)aligned_alloc(32, sizeof(float) * NI * NJ);
	init_zero(Check, NI, NJ);
	for (int i = 0; i < NI; i++) {
		for (int j = 0; j < NJ; j++) {
			for (int k = 0; k < NK; k++) {
				Check[i * NJ + j] += A[i * NK + k] * B[k * NJ + j];
			}
		}
	}
	for (int i = 0; i < NI; i++) {
		for (int j = 0; j < NJ; j++) {
			if (Check[i * NJ + j] - C[i * NJ + j] > EPSILON) assert(0);
		}
	}
	return 1;
}
void matmul(float * A, float * B, float * C) {
	int i, i0, ip_0, j, j0, jp_0, j0_p_0, j1, jp_1, k, k0, kp_0;
	float * B3 = (float *)aligned_alloc(32, sizeof(float) * 8192);
	float * B2 = (float *)aligned_alloc(32, sizeof(float) * 8192);
	float * B1 = (float *)aligned_alloc(32, sizeof(float) * 256);
	float scal_0;
	__m256 vec_0 ,vec_1 ,vec_2 ,vec_3 ,vec_4;
	for (i0 = 0;
			i0 < I;
			i0 += 32){
		for (j1 = 0;
				j1 < J;
				j1 += 4096){
			for (k0 = 0;
					k0 < K;
					k0 += 32){
				for (j0 = j1, j0_p_0 = 0;
						j0 < MIN(j1 + 4096, J);
						j0 += 256, j0_p_0 += 256){
					for (k = k0, kp_0 = 0;
							k < MIN(k0 + 32, K);
							k += 1, kp_0 += 1){
						for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
								j < MIN(j0 + 256, J);
								j += 8, jp_1 += 8, jp_0 += 8){
							vec_0 = _mm256_load_ps(&B[J * k + j]);
							_mm256_store_ps(&B3[256 * kp_0 + jp_0], vec_0);
						}
					}
					for (i = i0, ip_0 = 0;
							i < MIN(i0 + 32, I);
							i += 1, ip_0 += 1){
						for (k = k0, kp_0 = 0;
								k < MIN(k0 + 32, K);
								k += 1, kp_0 += 1){
							for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
									j < MIN(j0 + 256, J);
									j += 8, jp_1 += 8, jp_0 += 8){
								vec_0 = _mm256_load_ps(&B3[256 * kp_0 + jp_0]);
								_mm256_store_ps(&B2[256 * kp_0 + jp_0], vec_0);
							}
						}
						for (k = k0, kp_0 = 0;
								k < MIN(k0 + 32, K);
								k += 1, kp_0 += 1){
							for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
									j < MIN(j0 + 256, J);
									j += 8, jp_1 += 8, jp_0 += 8){
								vec_0 = _mm256_load_ps(&B2[256 * kp_0 + jp_0]);
								_mm256_store_ps(&B1[jp_0], vec_0);
							}
							for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
									j < MIN(j0 + 256, J);
									j += 8, jp_1 += 8, jp_0 += 8){
								vec_1 = _mm256_load_ps(&C[J * i + j]);
								scal_0 = A[K * i + k];
								vec_3 = _mm256_set1_ps(scal_0);
								vec_4 = _mm256_load_ps(&B1[jp_0]);
								vec_2 = _mm256_mul_ps(vec_3, vec_4);
								vec_0 = _mm256_add_ps(vec_1, vec_2);
								_mm256_store_ps(&C[J * i + j], vec_0);
							}
							for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
									j < MIN(j0 + 256, J);
									j += 8, jp_1 += 8, jp_0 += 8){
								vec_0 = _mm256_load_ps(&B1[jp_0]);
								_mm256_store_ps(&B2[256 * kp_0 + jp_0], vec_0);
							}
						}
						for (k = k0, kp_0 = 0;
								k < MIN(k0 + 32, K);
								k += 1, kp_0 += 1){
							for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
									j < MIN(j0 + 256, J);
									j += 8, jp_1 += 8, jp_0 += 8){
								vec_0 = _mm256_load_ps(&B2[256 * kp_0 + jp_0]);
								_mm256_store_ps(&B3[256 * kp_0 + jp_0], vec_0);
							}
						}
					}
					for (k = k0, kp_0 = 0;
							k < MIN(k0 + 32, K);
							k += 1, kp_0 += 1){
						for (j = j0, jp_1 = j0_p_0, jp_0 = 0;
								j < MIN(j0 + 256, J);
								j += 8, jp_1 += 8, jp_0 += 8){
							vec_0 = _mm256_load_ps(&B3[256 * kp_0 + jp_0]);
							_mm256_store_ps(&B[J * k + j], vec_0);
						}
					}
				}
			}
		}
	}
}
int main() {
  float (*const A) = (float *)aligned_alloc(32, sizeof(float) * I * K);
  float (*const B) = (float *)aligned_alloc(32, sizeof(float) * K * J);
  float *C = (float *)aligned_alloc(32, sizeof(float) * I * J);
  init_rand(A, I, K);
  init_rand(B, K, J);
  init_zero(C, I, J);
  matmul(A, B, C);
  printf("Matmul is true: %d\n", is_matmul(A, B, C, I, J, K));
}
